/*
 *  Hojear base de jugadores
 */
Function HojearBaseJugs()

	if !file(cUnidadProg+':\'+cCaminoProg+'\ks\basejugs.dbf')

	   use (cUnidadProg+':\'+cCaminoProg+'\ks\basejugs.mod') new
	   COPY STRU TO (cUnidadProg+':\'+cCaminoProg+'\ks\basejugs')
	   use (cUnidadProg+':\'+cCaminoProg+'\ks\basejugs') alias bjugs exclusive
	   dbcreateindex(cUnidadProg+':\'+cCaminoProg+'\ks\basejugs' , 'bjugs->jug' , { || bjugs->jug } )
		
	else
	
		use (cUnidadProg+':\'+cCaminoProg+'\ks\basejugs') alias bjugs new exclusive
		if !file(cUnidadProg+':\'+cCaminoProg+'\ks\basejugs.ntx')
			dbcreateindex(cUnidadProg+':\'+cCaminoProg+'\ks\basejugs','upper(bjugs->jug)',{ || upper(bjugs->jug) })
		else
			ordlistadd(cUnidadProg+':\'+cCaminoProg+'\ks\basejugs')
		endif
	
	endif

	LOAD WINDOW kshojearbase AS FrmHBase
	
	  FrmHBase.Center
	  FrmHBase.Activate
	  //FrmHPr.Release
	
	bjugs->(dbclosearea())

Return nil

/*
 *  Aadir jugadores del torneo activo a la base de jugadores
 */
Function AnaJugsaBase()
local lAct:=.f., aCampos

if MsgYesNo('Aadir los jugadores del torneo a la base?','Base de jugadores')

	if MsgYesNo('Actualizar en la base los datos de los jugadores que ya existan?','Base de jugadores')
		lAct:=.t.
	endif

	if !file(cUnidadProg+':\'+cCaminoProg+'\ks\basejugs.dbf')

	   use (cUnidadProg+':\'+cCaminoProg+'\ks\basejugs.mod') new
	   COPY STRU TO (cUnidadProg+':\'+cCaminoProg+'\ks\basejugs')
	   use (cUnidadProg+':\'+cCaminoProg+'\ks\basejugs') alias bjugs exclusive
	   dbcreateindex(cUnidadProg+':\'+cCaminoProg+'\ks\basejugs' , 'bjugs->jug' , { || bjugs->jug } )

	else
	
		use (cUnidadProg+':\'+cCaminoProg+'\ks\basejugs') alias bjugs new exclusive
		if !file(cUnidadProg+':\'+cCaminoProg+'\ks\basejugs.ntx')
			dbcreateindex(cUnidadProg+':\'+cCaminoProg+'\ks\basejugs','upper(bjugs->jug)',{ || upper(bjugs->jug) })
		else
			ordlistadd(cUnidadProg+':\'+cCaminoProg+'\ks\basejugs')
		endif
		//	index (cUnidadProg+':\'+cCaminoProg+'\ks\basejugs') exclusive
	
	endif
	
	aCampos := bjugs->(dbstruct())
	
	dbselectarea('cuadro')
	dbeval( { || AnaJugaBase(lAct,aCampos) } )

	bjugs->(dbclosearea())
	   
endif

Return nil

/*
 *  Aadir un jugador a la base de jugadores
 */
Function AnaJugaBase(lAct,aCampos)

//Buscar jugador para ver si ya est en la base
dbselectarea('bjugs')
dbseek(MayMins(cuadro->jug))

if found()
	//Jugador ya en la base, actualizar datos
	aeval( aCampos, {|aCampo| ActCampo(upper(aCampo[1]),lAct)} )
else
	//Jugador q no esta en la base, aadirlo
	bjugs->(dbappend())
	aeval( aCampos, {|aCampo| ActCampo(upper(aCampo[1]),.t.)} )
endif

dbselectarea('cuadro')

Return nil

/*
 *  Actualizar campo en base
 */
Function ActCampo(cCampo,lAct)
local cCpoCuadro:='cuadro->'+cCampo, cCpoBase:='bjugs->'+cCampo

if lAct 
	if !empty(&cCpoCuadro)
		if cCampo$'JUG.CLUB'
			replace &cCpoBase with MayMins(&cCpoCuadro)
		else
			replace &cCpoBase with &cCpoCuadro
		endif
	endif
else
	if empty(&cCpoBase)
		if cCampo$'JUG.CLUB'
			replace &cCpoBase with MayMins(&cCpoCuadro)
		else
			replace &cCpoBase with &cCpoCuadro
		endif
	endif
endif

Return nil

/*
 *  Aadir jugador de la base al torneo actual
 */
Function AnaJugaCuadro()
local aCampos

	bjugs->(dbgoto(FrmHBase.brwBJugs.Value))
	aCampos := bjugs->(dbstruct())
	
	cuadro->(dbappend())
	if !neterr()
	
		aeval( aCampos, {|aCampo| ActCampoJaC(upper(aCampo[1]))} )
		
		if torneos->(dbrlock())
			replace torneos->n_jugs with torneos->n_jugs+1
			torneos->(dbunlock())
			// Si n_jugs ahora es impar se necesitar un reg mas en los fichs de rondas
	    	if torneos->n_jugs<>2*int(torneos->n_jugs/2)
        		for i:=1 to torneos->n_rondas
          			cFich="r"+STR(i,nCifrasNRdas)+alltrim(torneos->fichero)
          		    use (cFich) alias ronda new exclusive
          		    ronda->(dbappend())
          		    ronda->(dbclosearea())
                next
            endif

		else
			MsgInfo('No se ha podido aumentar n 1 el n de jugadores del torneo'+CRLF+;
				'Deber hacerlo a mano')
		endif
		
		MsgInfo('Se ha aadido el jugador al torneo')
		
	else
	
		MsgInfo('No se ha podido aadir el jugador'+CRLF+;
				'Compruebe que el cuadro del torneo no est abierto por otro programa')
	
	endif
	
Return nil				

/*
 *  Actualizar campo en cuadro
 */
Function ActCampoJaC(cCampo)
local cCpoCuadro:='cuadro->'+cCampo, cCpoBase:='bjugs->'+cCampo

	replace &cCpoCuadro with &cCpoBase

Return nil
    
/*
 *  Buscar principio del jugador
 */
Function Buscar()

local cBuscar:=upper(alltrim(FrmHBase.txtBuscar.value))
local nReg

  //MsgInfo(MayMins(cBuscar))

  dbseek(cBuscar,.t.)
  nReg:=recno()
  FrmHBase.brwBJugs.Value:=nReg

Return Nil

/*
 *  Borrar jugador
 */
Function BorrarJug()

  bjugs->(dbgoto(FrmHBase.brwBJugs.Value))

  if MsgYesNo('Confirme borrado del jugador:'+CRLF+bjugs->jug)
    if bjugs->(rlock())
      bjugs->(dbdelete())
      bjugs->(dbunlock())
    else
      MsgInfo('No se ha podido eliminar el jugador')
    endif
  endif

  FrmHBase.brwBJugs.Refresh

Return nil

/*
 * Editar un jugador de la base
 */
 
Function EditarJugBase()  

	bjugs->(dbgoto(FrmHBase.brwBJugs.Value))

	LOAD WINDOW kseditarjugbase AS FrmEdJugBase

  FrmEdJugBase.txtJUG.Value:=bjugs->JUG
  FrmEdJugBase.txtLIC.Value:=bjugs->LIC
  FrmEdJugBase.txtELOFIDE.Value:=bjugs->ELOFIDE
  FrmEdJugBase.txtELOFEDA.Value:=bjugs->ELOFEDA
  FrmEdJugBase.txtELO.Value:=bjugs->ELO
  FrmEdJugBase.txtK.Value:=bjugs->K
  FrmEdJugBase.txtCLUB.Value:=bjugs->CLUB
  FrmEdJugBase.txtCAT.Value:=bjugs->CAT
  FrmEdJugBase.txtCOD_PAIS.Value:=bjugs->COD_PAIS
  FrmEdJugBase.txtCOD_FIDE.Value:=bjugs->COD_FIDE
  FrmEdJugBase.txtCOD_FEDA.Value:=bjugs->COD_FEDA
  FrmEdJugBase.fecFECHA_NAC.Value:=bjugs->FECHA_NAC

  FrmEdJugBase.Center
  FrmEdJugBase.Activate
  //FrmEdJugBaseEdPr.Release
  FrmHBase.brwBJugs.Refresh

Return nil

/*
 * Grabar jugador
 */
 
Function fEdJugOk()

if rlock()

  REPLACE bjugs->JUG WITH FrmEdJugBase.txtJUG.Value
  REPLACE bjugs->LIC WITH FrmEdJugBase.txtLIC.Value
  REPLACE bjugs->ELOFIDE WITH FrmEdJugBase.txtELOFIDE.Value
  REPLACE bjugs->ELOFEDA WITH FrmEdJugBase.txtELOFEDA.Value
  REPLACE bjugs->ELO WITH FrmEdJugBase.txtELO.Value
  REPLACE bjugs->K WITH FrmEdJugBase.txtK.Value
  REPLACE bjugs->CLUB WITH FrmEdJugBase.txtCLUB.Value
  REPLACE bjugs->CAT WITH FrmEdJugBase.txtCAT.Value
  REPLACE bjugs->COD_PAIS WITH FrmEdJugBase.txtCOD_PAIS.Value
  REPLACE bjugs->COD_FIDE WITH FrmEdJugBase.txtCOD_FIDE.Value
  REPLACE bjugs->COD_FEDA WITH FrmEdJugBase.txtCOD_FEDA.Value
  REPLACE bjugs->FECHA_NAC WITH FrmEdJugBase.fecFECHA_NAC.Value

  bjugs->(dbunlock())
  
else
  MsgInfo('No se ha podido grabar el jugador')

endif

FrmEdJugBase.Release

Return nil

/*
 * Nuevo jugador en la base
 */
 
Function NuevoJugBase()  

	LOAD WINDOW ksnuevojugbase AS FrmNuJugBase

  FrmNuJugBase.txtJUG.Value:=space(20)			//bjugs->JUG
  FrmNuJugBase.txtLIC.Value:=space(5)			//bjugs->LIC
  FrmNuJugBase.txtELOFIDE.Value:=0				//bjugs->ELOFIDE
  FrmNuJugBase.txtELOFEDA.Value:=0				//bjugs->ELOFEDA
  FrmNuJugBase.txtELO.Value:=0					//bjugs->ELO
  FrmNuJugBase.txtK.Value:=25					//bjugs->K
  FrmNuJugBase.txtCLUB.Value:=space(20)			//bjugs->CLUB
  FrmNuJugBase.txtCAT.Value:=' '				//bjugs->CAT
  FrmNuJugBase.txtCOD_PAIS.Value:='   '			//bjugs->COD_PAIS
  FrmNuJugBase.txtCOD_FIDE.Value:=space(8)		//bjugs->COD_FIDE
  FrmNuJugBase.txtCOD_FEDA.Value:=space(8)		//bjugs->COD_FEDA
  //FrmNuJugBase.fecFECHA_NAC.Value:=ctod('  -  -    ')	//bjugs->FECHA_NAC

  FrmNuJugBase.Center
  FrmNuJugBase.Activate
  //FrmNuJugBaseEdPr.Release
  FrmHBase.brwBJugs.Refresh

Return nil

/*
 * Grabar jugador nuevo
 */
 
Function fNuJugOk()

bjugs->(dbappend())
if !neterr()

  REPLACE bjugs->JUG WITH FrmNuJugBase.txtJUG.Value
  REPLACE bjugs->LIC WITH FrmNuJugBase.txtLIC.Value
  REPLACE bjugs->ELOFIDE WITH FrmNuJugBase.txtELOFIDE.Value
  REPLACE bjugs->ELOFEDA WITH FrmNuJugBase.txtELOFEDA.Value
  REPLACE bjugs->ELO WITH FrmNuJugBase.txtELO.Value
  REPLACE bjugs->K WITH FrmNuJugBase.txtK.Value
  REPLACE bjugs->CLUB WITH FrmNuJugBase.txtCLUB.Value
  REPLACE bjugs->CAT WITH FrmNuJugBase.txtCAT.Value
  REPLACE bjugs->COD_PAIS WITH FrmNuJugBase.txtCOD_PAIS.Value
  REPLACE bjugs->COD_FIDE WITH FrmNuJugBase.txtCOD_FIDE.Value
  REPLACE bjugs->COD_FEDA WITH FrmNuJugBase.txtCOD_FEDA.Value
  //if bjugs->FECHA_NAC<>ctod('01-01-1901')
  	REPLACE bjugs->FECHA_NAC WITH FrmNuJugBase.fecFECHA_NAC.Value
  //endif

  bjugs->(dbunlock())
  
else
  MsgInfo('No se ha podido grabar el jugador')

endif

FrmNuJugBase.Release

Return nil

/*
 * Actualizar FIDE de los jugadores con cdigo
 */       
 
Function ActFIDE()
private nKEnc:=0, nKMod:=0, cFichFIDE:=''

if file(GetWindowsFolder()+'\av.ini')
	BEGIN INI FILE GetWindowsFolder()+'\av.ini'
    	GET cFichFIDE SECTION 'KersuizoW' ENTRY 'EloFide' DEFAULT ''
	END INI
endif

//MsgInfo(cFichFIDE)
//MsgInfo(EMPTY(cFichFIDE))

if EMPTY(cFichFIDE) .or. !file(cFichFIDE)

	MsgExclamation('Seleccione la ubicacin del Elo FIDE en el Men Configurar')

else

	use (cFichFIDE) alias ffide new exclusive
	dbcreateindex(cUnidadProg+':\'+cCaminoProg+'\ffide.tmp','ffide->cod_fide',{ || ffide->cod_fide })
	
	bjugs->(dbgotop())
	bjugs->(dbeval( { || ActFIDEJug() } , { || len(trim(bjugs->cod_fide))>0 } ))
	
	ffide->(dbclosearea())
	ERASE (cUnidadProg+':\'+cCaminoProg+'\ffide.tmp')
	dbselectarea('bjugs')
	
	FrmHBase.brwBJugs.Refresh	
	MsgInfo('Jugadores encontrados: '+alltrim(str(nKEnc))+CRLF+ ;
			'ELOs actualizados: '+alltrim(str(nKMod)))

endif

Return nil

/*
 * Actualizar Elo FIDE de un jugador
 */
 
Function ActFIDEJug()

ffide->(dbseek(val(bjugs->cod_fide)))
if ffide->(found())
	nKEnc++
	if bjugs->elofide <> ffide->elo
		nKMod++
		REPLACE bjugs->elofide with ffide->elo
	endif
endif

Return nil

/*
 * Actualizar FEDA de los jugadores con cdigo
 */       
 
Function ActFEDA()
private nKEnc:=0, nKMod:=0, cFichFEDA:=''

if file(GetWindowsFolder()+'\av.ini')
	BEGIN INI FILE GetWindowsFolder()+'\av.ini'
    	GET cFichFEDA SECTION 'KersuizoW' ENTRY 'EloFeda' DEFAULT ''
	END INI
endif

//MsgInfo(cFichFEDA)
//MsgInfo(EMPTY(cFichFEDA))

if EMPTY(cFichFEDA) .or. !file(cFichFEDA)

	MsgExclamation('Seleccione la ubicacin del Elo FEDA en el Men Configurar')

else

	use (cFichFEDA) alias ffeda new exclusive
	dbcreateindex(cUnidadProg+':\'+cCaminoProg+'\ffeda.tmp','ffeda->clave',{ || ffeda->clave })
	
	bjugs->(dbgotop())
	bjugs->(dbeval( { || ActFEDAJug() } , { || len(trim(bjugs->cod_feda))>0 } ))
	
	ffeda->(dbclosearea())
	ERASE (cUnidadProg+':\'+cCaminoProg+'\ffeda.tmp')
	dbselectarea('bjugs')
	
	FrmHBase.brwBJugs.Refresh	
	MsgInfo('Jugadores encontrados: '+alltrim(str(nKEnc))+CRLF+ ;
			'ELOs actualizados: '+alltrim(str(nKMod)))

endif

Return nil

/*
 * Actualizar Elo FEDA de un jugador
 */
 
Function ActFEDAJug()

ffeda->(dbseek(val(bjugs->cod_feda)))
if ffeda->(found())
	nKEnc++
	if bjugs->elofeda <> ffeda->ranking
		nKMod++
		REPLACE bjugs->elofeda with ffeda->ranking
	endif
endif

Return nil

/*
 * Buscar Cdigo FIDE de los jugadores a partir del nombre
 */       
 
Function BusCodFIDE()
private nKEnc:=0, cFichFIDE:='', nKAmbiguos:=0 //nKMod:=0, 

if file(GetWindowsFolder()+'\av.ini')
	BEGIN INI FILE GetWindowsFolder()+'\av.ini'
    	GET cFichFIDE SECTION 'KersuizoW' ENTRY 'EloFide' DEFAULT ''
	END INI
endif

if EMPTY(cFichFIDE) .or. !file(cFichFIDE)

	MsgExclamation('Seleccione la ubicacin del Elo FIDE en el Men Configurar')

else

	use (cFichFIDE) alias ffide new exclusive
	dbcreateindex(cUnidadProg+':\'+cCaminoProg+'\ffide.tmp','ffide->jug',{ || ffide->jug })
	
	bjugs->(dbgotop())
	// De momento busco los que no tienen cdigo FIDE, aunque podra ser
	// interesante tambin comprobar q los cods que hay son correctos   
	bjugs->(dbeval( { || BusCodFIDEJug() } , { || len(trim(bjugs->cod_fide))=0 } ))
	
	ffide->(dbclosearea())
	ERASE (cUnidadProg+':\'+cCaminoProg+'\ffide.tmp')
	dbselectarea('bjugs')
	
	FrmHBase.brwBJugs.Refresh	
	MsgInfo('Jugadores encontrados: '+alltrim(str(nKEnc))+CRLF+ ;
			'Jugadores ambiguos: '+alltrim(str(nKAmbiguos)))

endif

Return nil

/*
 * Poner Cdigo FIDE al jugador
 */
 
Function BusCodFIDEJug()

ffide->(dbseek(trim(bjugs->jug)))
if ffide->(found())
	nKEnc++
	ffide->(dbskip())
	if trim(bjugs->jug)<>trim(ffide->jug)
		// Solo actualizo si el sig. jug ya no coincide con el buscado
		ffide->(dbskip(-1))
		REPLACE bjugs->cod_fide with str(ffide->cod_fide,8)
	else
		// Si sig jug sigue coincidiendo con lo buscado -> ambiguo
		nKAmbiguos++
	endif
endif

Return nil

/*
 * Buscar Cdigo FEDA de los jugadores a partir del nombre
 */       
 
Function BusCodFEDA()


Return nil

/*
 * Actualizar FIDE de los jugadores con cdigo
 */       
 
Function ActFVA()
private nKEnc:=0, nKMod:=0, cFichFVA:=''

if file(GetWindowsFolder()+'\av.ini')
	BEGIN INI FILE GetWindowsFolder()+'\av.ini'
    	GET cFichFVA SECTION 'KersuizoW' ENTRY 'EloFva' DEFAULT ''
	END INI
endif

if EMPTY(cFichFVA) .or. !file(cFichFVA)

	MsgExclamation('Seleccione la ubicacin del Elo FVA en el Men Configurar')

else

	use (cFichFVA) alias ffva new exclusive
	dbcreateindex(cUnidadProg+':\'+cCaminoProg+'\ffva.tmp','ffva->lic',{ || ffva->lic })
	
	bjugs->(dbgotop())
	bjugs->(dbeval( { || ActFVAJug() } , { || len(trim(bjugs->lic))>0 } ))
	
	ffva->(dbclosearea())
	ERASE (cUnidadProg+':\'+cCaminoProg+'\ffva.tmp')
	dbselectarea('bjugs')
	
	FrmHBase.brwBJugs.Refresh	
	MsgInfo('Jugadores encontrados: '+alltrim(str(nKEnc))+CRLF+ ;
			'ELOs actualizados: '+alltrim(str(nKMod)))

endif

Return nil

/*
 * Actualizar Elo FVA de un jugador
 */
 
Function ActFVAJug()

ffva->(dbseek(bjugs->lic))
if ffva->(found())
	nKEnc++
	if bjugs->elo <> ffva->elo
		nKMod++
		REPLACE bjugs->elo with ffva->elo
	endif
endif

Return nil

/*
 * Buscar Licencia FVA de los jugadores a partir del nombre
 */       
 
Function BusCodFVA()
private nKEnc:=0, cFichFVA:='', nKAmbiguos:=0

if file(GetWindowsFolder()+'\av.ini')
	BEGIN INI FILE GetWindowsFolder()+'\av.ini'
    	GET cFichFVA SECTION 'KersuizoW' ENTRY 'EloFva' DEFAULT ''
	END INI
endif

if EMPTY(cFichFVA) .or. !file(cFichFVA)

	MsgExclamation('Seleccione la ubicacin del Elo FVA en el Men Configurar')

else

	use (cFichFVA) alias ffva new exclusive
	dbcreateindex(cUnidadProg+':\'+cCaminoProg+'\ffva.tmp','upper(ffva->jug)',{ || upper(ffva->jug) })
	
	bjugs->(dbgotop())
	// De momento busco los que no tienen cdigo FIDE, aunque podra ser
	// interesante tambin comprobar q los cods que hay son correctos   
	bjugs->(dbeval( { || BusCodFVAJug() } , { || len(trim(bjugs->lic))=0 } ))
	
	ffva->(dbclosearea())
	ERASE (cUnidadProg+':\'+cCaminoProg+'\ffva.tmp')
	dbselectarea('bjugs')

	FrmHBase.brwBJugs.Refresh	
	MsgInfo('Jugadores encontrados: '+alltrim(str(nKEnc))+CRLF+ ;
			'Jugadores ambiguos: '+alltrim(str(nKAmbiguos)))

endif

Return nil

/*
 * Poner Licencia FVA al jugador
 */
 
Function BusCodFVAJug()

ffva->(dbseek(upper(trim(bjugs->jug))))
if ffva->(found())
	nKEnc++
	ffva->(dbskip())
	if upper(trim(bjugs->jug))<>upper(trim(ffva->jug))
		// Solo actualizo si el sig. jug ya no coincide con el buscado
		ffva->(dbskip(-1))
		REPLACE bjugs->lic with ffva->lic
	else
		// Si sig jug sigue coincidiendo con lo buscado -> ambiguo
		nKAmbiguos++
	endif
endif

Return nil
