/*
 * FigImpP - Importacin de emparejamiento y resultados desde Fgaro
 */
 
Function FigImpP
local cTexto, nPos

cFich:=''

//MsgInfo(curdir())

cFich:=GetFile ( {{"Listados de Fgaro", "*.txt"}} , 'Elegir fichero',;
  cUnidadProg+':\'+cCaminoProg , .f. , .t.)

//MsgInfo(curdir())
  
cTexto:=FileRead(cFich)

if !empty(cTexto)

	//Tratar texto
	nPos:=at('Ronda',cTexto)
	if nPos=0
		MsgStop('No se puede interpretar el fichero')
	else
		nRonda:=val(substr(cTexto,nPos+5,3))
		if MsgYesNo('Confirme la importacin de la Ronda '+alltrim(str(nRonda)))
			use ('r'+alltrim(str(nRonda))+cCodTorneo) alias ronda exclusive new
			//cFichRda='r'+alltrim(str(nRonda))+cCodTorneo
			//use (cFichRda) alias ronda new
			FigImpP1(ltrim(substr(cTexto,nPos+8)))
			ronda->(dbclosearea())
		endif
	endif
  
endif
	  
Return nil

/*
 */
 
Function FigImpP1(cTexto)
local nMesa:=1, cBusq, nPos, cJugB:='', cJugN:='', cRdo:=''

cBusq:=alltrim(str(nMesa))+'.-'
nPos:=at(cBusq,cTexto)
do while nPos>0
	// Tratar mesa
	//cJugB+=substr(cTexto,nPos+len(cBusq)+1,3)+' - '
	//cJugN+=substr(cTexto,nPos+len(cBusq)+1+3+34,3)+' - '
	// cRdo+=substr(cTexto,nPos+len(cBusq)+1+3+30,3)+' - '
	if ronda->(eof())
		ronda->(dbappend())
	endif
	replace ronda->jug_b with val(substr(cTexto,nPos+len(cBusq)+1,3))
	replace ronda->jug_n with val(substr(cTexto,nPos+len(cBusq)+1+3+34,3))
	replace ronda->rdo  with F_RdoFig(substr(cTexto,nPos+len(cBusq)+1+3+30,3),nMesa)
	ronda->(dbskip())
	
	// Buscar sig. mesa
	nMesa++
	cBusq:=alltrim(str(nMesa))+'.-'
	nPos:=at(cBusq,cTexto)
enddo
//MsgInfo(cJugB)
//MsgInfo(cJugN)
//MsgInfo(cRdo)

Return nil 
 
/*
 * F_RdoFig - Transforma el resultado de Figaro al de KersuizoW
 */ 

Function F_RdoFig(cRdo,nMesa)

Do case
case cRdo$'1-0.0-1.-'
	cRdo:=' '+cRdo+' '
case cRdo='+--'
	cRdo:=' 1-0i'
case cRdo='--+'
	cRdo:='i0-1 '
case cRdo='---'
	cRdo:='i0-0i'
case cRdo=' - ' .or. cRdo='   '
	// No hay rdo
	cRdo:='     '
othe
	MsgInfo('Resultado desconocido en la Mesa '+alltrim(str(nMesa)))
endcase

Return cRdo 
 
/*
 */ 
  
*--------------------------------------------------------*
Function FileRead( cFile )
*--------------------------------------------------------*
   Local nHandle, cBuffer := SPACE(512), nRead := 1, cText := ""

IF !EMPTY(cFile)
   nHandle := FOPEN(cFile, 2)

   IF FERROR() <> 0

      MsgStop("Error en la apertura del fichero")
      RETURN ""

   ENDIF

   DO WHILE nRead <> 0

	nRead := FREAD(nHandle, @cBuffer, 512)

	IF nRead <> 512

         cBuffer := SUBSTR(cBuffer, 1, nRead)

      ENDIF

      cText += cBuffer

   ENDDO

   FCLOSE(nHandle)
ENDIF

return( cText )