/*
 *  Listado de papeletas de resultados
 */

Function LisPapRdos()
local aRondas[torneos->n_rondas], cFichRda, cFecha
private nKPag

aeval(aRondas, {|cValor,nIndice| aRondas[nIndice] := alltrim(str(nIndice)) } )

LOAD WINDOW ksronda AS FrmElegRda

	FrmElegRda.lblFichero.Visible:=.f.
	FrmElegRda.txtFichero.Visible:=.f.
	FrmElegRda.lblRonda.Row:=40
	FrmElegRda.cbxRdas.Row:=40

	CENTER WINDOW FrmElegRda
	ACTIVATE WINDOW FrmElegRda
  
	//La ronda elegida est en nRonda y el nombre del fichero en cFich
	cFichRda='r'+alltrim(str(nRonda))+cCodTorneo
	use (cFichRda) alias ronda new

	cFecha:=if(torneos->fecha_ini<>torneos->fecha_fin,'del '+ ;
            dtoc(torneos->fecha_ini)+' al '+dtoc(torneos->fecha_fin),dtoc(torneos->fecha_ini))

	// Initialize print system
	INIT PRINTSYS
	// Let the user to select a printer via dialog
	SELECT BY DIALOG 
	// If the error code is not zero cancel print
	IF HBPRNERROR != 0 
		MSGSTOP ('Impresin cancelada!')
		Return nil
	ENDIF

	// The best way to get the most similiar printout on various printers 
	// is to use SET UNITS MM, remembering to use margins large enough for 
	// all printers.
	SET UNITS MM    		// Sets @... units to milimeters
	SET PAPERSIZE DMPAPER_A4	// Sets paper size to A4
	SET ORIENTATION PORTRAIT	// Sets paper orientation to portrait
	SET BIN DMBIN_FIRST    		// Use first bin
	//SET QUALITY DMRES_HIGH		// Sets print quality to high
	//SET COLORMODE DMCOLOR_COLOR	// Set print color mode to color
	SET PREVIEW ON			// Enables print preview

	// Create a font for use with @...SAY command
	DEFINE FONT "FontTit" 	NAME "Arial" SIZE 20 BOLD
	DEFINE FONT "FontTit2" 	NAME "Arial" SIZE 14
	DEFINE FONT "FontText1" NAME "Times New Roman" SIZE 12
	DEFINE FONT "FontTextRes1" NAME "Arial" SIZE 14 BOLD

	START DOC
		START PAGE
			nKPag:=1
			nKLin:=0
			dbeval({|| ProcPapRdos(cFecha)},{|| ronda->jug_b<>0})
		END PAGE
	END DOC
	
	// Releases print system
	RELEASE PRINTSYS

	ronda->(dbclosearea())
	
Return nil

/*
 * ProcPapRdos - Impresin de una papeleta de recogida de resultados
 */
 
Function ProcPapRdos(cFecha)

	@ nKLin*65+25,15,nKLin*65+70,195 RECTANGLE

	@ nKLin*65+30,20 SAY alltrim(torneos->torneo) ;
					FONT "FontTit" ;
					TO PRINT
	@ nKLin*65+36,20 SAY trim(torneos->localidad)+', '+cFecha ;
					FONT "FontTit2" ;
					TO PRINT
	@ nKLin*65+41,20,nKLin*65+41,190 LINE
	
	@ nKLin*65+49,20 SAY 'Ronda:' FONT "FontText1" TO PRINT
	@ nKLin*65+46,35,nKLin*65+56,50 RECTANGLE
	@ nKLin*65+49,40 SAY str(nRonda,2) FONT "FontTextRes1" TO PRINT

	@ nKLin*65+59,20 SAY 'Mesa:' FONT "FontText1" TO PRINT
	@ nKLin*65+56,35,nKLin*65+66,50 RECTANGLE
	@ nKLin*65+59,38 SAY str((nKPag-1)*4+nKLin+1,3) FONT "FontTextRes1" TO PRINT

	cuadro->(dbgoto(ronda->jug_b))
	@ nKLin*65+49,55 SAY 'Blancas:' FONT "FontText1" TO PRINT
	@ nKLin*65+49,70 SAY '('+str(cuadro->num,3)+') '+cuadro->jug FONT "FontTextRes1" TO PRINT
	
	cuadro->(dbgoto(ronda->jug_n))
	@ nKLin*65+59,55 SAY 'Negras:' FONT "FontText1" TO PRINT
	@ nKLin*65+59,70 SAY '('+str(cuadro->num,3)+') '+cuadro->jug FONT "FontTextRes1" TO PRINT
	
	@ nKLin*65+48,165 SAY 'Resultado:' FONT "FontText1" TO PRINT
	@ nKLin*65+53,165,nKLin*65+63,190 RECTANGLE

	//@ nKLin*65+70,20,nKLin*65+70,190 LINE
		
	nKLin++

	if nKLin%4=0
		END PAGE
		START PAGE
		nKLin:=0
		nKPag++
	endif

Return nil
 