/*
  Modified by Gerardo Fernndez <gfh@euskalnet.net>
  03-19-2003
 */
/*
  HtmArch := Html_Create(cFile,cTitle)
  Html_LineText(HtmArch, '<p class="updated">Date:' + Dtoc(Date()) + "  " + "Time: " + Time() )
  Html_LineText(HtmArch, cMessage + "</p>" )
  Html_Line(HtmArch)


*/
*------------------------------------------------------------------------------
*-01-01-2003
*-AUTHOR: Antonio Novo
*-Create/Open the ErrorLog.Htm file
*-Note: Is used in: errorsys.prg and h_error.prg
*------------------------------------------------------------------------------
FUNCTION HTML_FILE(cFicheroHTML,cTitulo1)
*---------------------
    Local HtmArch := 0
    If .Not. File("\"+CurDir()+"\"+cFicheroHTML)
        HtmArch := Html_Ini("\"+CurDir()+"\"+cFicheroHTML,cTitulo1)
        Html_Line(HtmArch)
    Else
        HtmArch := FOPEN("\"+CurDir()+"\"+cFicheroHTML,2)
        FSeek(HtmArch,0,2)    //End Of File
    EndIf
RETURN (HtmArch)

*------------------------------------------------------------------------------
*-30-12-2002
*-AUTHOR: Antonio Novo
*-HTML Page Head
*------------------------------------------------------------------------------
FUNCTION HTML_INI(ARCH,TIT,TIT2)
*-------------------------
    LOCAL HTMARCH
    LOCAL cCSS:='<link rel="stylesheet" href="kersuizo.css" type="text/css">'

    LOCAL cStilo:= "<style> "                       +;
                     "body{ "                       +;
                       "font-family: sans-serif;"   +;
                       "background-color: #ffffff;" +;
                       "font-size: 75%;"            +;
                       "color: #000000;"            +;
                       "}"                          +;
                     "h1{"                          +;
                       "font-family: sans-serif;"   +;
                       "font-size: 150%;"           +;
                       "color: #0000cc;"            +;
                       "font-weight: bold;"         +;
                       "background-color: #f0f0f0;" +;
                       "}"                          +;
                     "h2{"                          +;
                       "font-family: sans-serif;"   +;
                       "font-size: 100%;"           +;
                       "color: #0000cc;"            +;
                       "font-weight: bold;"         +;
                       "background-color: #f0f0f0;" +;
                       "}"                          +;
                     ".updated{"                    +;
                       "font-family: sans-serif;"   +;
                       "color: #cc0000;"            +;
                       "font-size: 110%;"           +;
                       "}"                          +;
                     ".normaltext{"                 +;
                      "font-family: sans-serif;"    +;
                      "font-size: 100%;"            +;
                      "color: #000000;"             +;
                      "font-weight: normal;"        +;
                      "text-transform: none;"       +;
                      "text-decoration: none;"      +;
                    "}"                             +;
                    "</style>"

    HTMARCH := FCREATE(ARCH)
//    FWRITE(HTMARCH,"<HTML><HEAD><TITLE>"+TIT+"</TITLE></HEAD>" + cStilo +"<BODY>"+CHR(13)+CHR(10))
    FWRITE(HTMARCH,"<HTML><HEAD><TITLE>"+TIT+"</TITLE>"+cCSS+"</HEAD>" + "<BODY>"+CHR(13)+CHR(10))
    FWRITE(HTMARCH,'<H1 Align=Center>'+TIT+'</H1>')
    FWRITE(HTMARCH,'<H2 Align=Center>'+TIT2+'</H2><BR>'+CHR(13)+CHR(10))
RETURN (HTMARCH)

*------------------------------------------------------------------------------
*-30-12-2002
*-AUTHOR: Antonio Novo
*-HTM Page Line
*------------------------------------------------------------------------------
FUNCTION HTML_LINETEXT(HTMARCH,LINEA)
*-----------------------------------
 //   LOCAL XLINEA
 //   XLINEA := RTRIM(LINEA)
    FWRITE(HTMARCH, RTRIM( LINEA ) + "<BR>"+CHR(13)+CHR(10))
RETURN (.T.)

*------------------------------------------------------------------------------
*-30-12-2002
*-AUTHOR: Antonio Novo
*-HTM Line
*------------------------------------------------------------------------------
FUNCTION HTML_LINE(HTMARCH)
*-------------------------
    FWRITE(HTMARCH,"<HR>"+CHR(13)+CHR(10))
RETURN (.T.)
*------------------------------------------------------------------------------
*-19-03-2003
*-AUTHOR: Gerardo Fernndez
*------------------------------------------------------------------------------
FUNCTION HTML_END(HTMARCH)
*-------------------------
    FWRITE(HTMARCH,"</BODY></HTML>")
    FCLOSE(HTMARCH)
RETURN (.T.)
*------------------------------------------------------------------------------
*-19-03-2003
*-AUTHOR: Gerardo Fernndez
*------------------------------------------------------------------------------
FUNCTION HTML_NEW(cFicheroHTML,cTitulo1)
*---------------------
    Local HtmArch := 0
        HtmArch := FOPEN("\"+CurDir()+"\"+cFicheroHTML,2)
        FSeek(HtmArch,0,2)    //End Of File
RETURN (HtmArch)
*------------------------------------------------------------------------------
*-19-03-2003
*-AUTHOR: Gerardo Fernndez
*------------------------------------------------------------------------------
FUNCTION HTML_LINETEXTK(HTMARCH,LINEA)
*-----------------------------------
    FWRITE(HTMARCH, RTRIM( LINEA ) +CHR(13)+CHR(10))
RETURN (.T.)
*------------------------------------------------------------------------------
*-19-03-2003
*-AUTHOR: Gerardo Fernndez
*------------------------------------------------------------------------------
FUNCTION HTML_TEXT(HTMARCH,LINEA)
*-----------------------------------
    FWRITE(HTMARCH, RTRIM( LINEA ))
RETURN (.T.)

/*
 */

Function FieldInFile(cField,cAlias)
local aCampos, lFound:=.f.

aCampos := &cAlias->(dbstruct())

aeval( aCampos, {|aCampo| (lFound:=if(upper(aCampo[1])=upper(cField),.t.,lFound))} )

Return lFound

/*
 * Funcin que pone la primera letra de cada palabra de un texto en maysculas y 
 * las dems en minsculas
/

Function MayMins(cTexto)
local cTextoN:='', nPos, cPal

nPos:=min(at(' ',cTexto),at(',',cTexto))
do while nPos>0
	cPal:=left(cTexto,nPos-1)
	cTextoN+=upper(left(cPal,1))+lower(substr(cPal,2))+trim(substr(cTexto,nPos,1))+' '
	cTexto:=ltrim(substr(cTexto,nPos+1))
	nPos:=min(at(' ',cTexto),at(',',cTexto))
enddo
cTextoN+=upper(left(cTexto,1))+lower(substr(cTexto,2))

Return cTextoN
*/

Function MayMins(cTexto)
local cTextoN:='', i, cAnt:=' ', cCar

for i:=1 to len(cTexto)

	cCar:=substr(cTexto,i,1)

	cTextoN+=if(cAnt$',.' .and. !EMPTY(cCar),' ','')
	cTextoN+=if(EMPTY(cAnt) .or. cAnt$',.',upper(cCar),lower(cCar))
		
	cAnt:=cCar
	
next
	
Return cTextoN

