/*
 * Kersuizo para Windows
 * Gerardo Fernndez <gfh@euskalnet.net>
 * http://www.AjedrezVasco.com
 */

#include "minigui.ch"
#include "kersuizow.ch"
#include "winprint.ch"

Static cCodTorneo, HtmFich, nKLin, nCifrasNRdas, cTipoList, nRonda, dw1, dw2, dw3, dw4, dw5, nKDes
Static aDesemps[20], cFichDs, cCaminoProg, cUnidadProg, cFich, cJug, i

/*
 * Programa principal
 */

Function Main

cCaminoProg:=CurDir()
cUnidadProg:=CurDrive()

LOAD WINDOW ksw AS Frm        // Carga la definicion de ventana de ksw.fmg

  CENTER WINDOW Frm
  
  Frm.mnuRdos.Enabled:=.f.
  //Frm.mnuInFIDE.Enabled:=.f.
  //Frm.mnuInFEDA.Enabled:=.f.
  Frm.mnuInFVA.Enabled:=.f.
  //Frm.mnuFFEDA.Enabled:=.f.
  Frm.mnuFFVA.Enabled:=.f.
 
  
  ACTIVATE WINDOW Frm
  RELEASE WINDOW MAIN

Return nil

/*
 */

Function ElegirTorneo()
local cCuadro:='', cTorneos, cVar

//cVar:=descend('a')

dbcloseall()

cCuadro:=GetFile ( {{"Archivos de cuadro", "cu*.dbf"}} , 'Elegir cuadro de torneo',;
  'c:\mis documentos\ajedrez\suizos2\' ) //'.\')

if len(trim(cCuadro))=0
	NoTorneo()
	Frm.Title:=APLICACION

else
	SiTorneo()
  
	use (cCuadro) alias cuadro new
	
	cTorneos:=left(cCuadro,rat('\',cCuadro))+'torneos'
	
	//use (cTorneos) index (cTorneos) alias torneos new
	use (cTorneos) alias torneos new
	cCodTorneo:=substr(cCuadro,rat('\',cCuadro)+1)
	cCodTorneo:=substr(cCodTorneo,3,len(cCodTorneo)-6)
	locate for upper(torneos->fichero)=upper(cCodTorneo)
	
	nCifrasNRdas:=if(torneos->n_rondas>9,2,1)
	Frm.Title:=APLICACION+' - '+torneos->torneo	
	
	// Comprobacin de que el torneo tiene todos los campos necesarios en KersuizoW
	if !FieldInFile("sexo","cuadro")
	   dbselectarea('cuadro')
	   use (cUnidadProg+':\'+cCaminoProg+'\ks\cuadrow.mod')
	   COPY STRU TO cuadrow.tmp
	   use cuadrow.tmp
	   APPEND FROM ('cu'+cCodTorneo)
	   dbclosearea()
	   //ERASE ('cu'+cCodTorneo+'.dbf')
	   if file('cu'+cCodTorneo+'.bak')
	      ERASE ('cu'+cCodTorneo+'.bak')
	   endif
	   RENAME ('cu'+cCodTorneo+'.dbf') TO ('cu'+cCodTorneo+'.bak')
	   RENAME cuadrow.tmp TO ('cu'+cCodTorneo+'.dbf')
	   use ('cu'+cCodTorneo) alias cuadro new
	
	   MsgInfo('KesuizoW ha aadido al torneo campos necesarios en esta versin'+;
	            CRLF+;        //chr(10)+chr(13)+;
	            'A partir de este momento no se debe utilizar la opcin '+;
	            CRLF+;        //chr(10)+chr(13)+;
	            'ACTUALIZAR ESTRUCTURA DE LOS FICHEROS de Kersuizo para DOS ')
	
	endif

endif

Return Nil

/*
 * Hojear torneos
 */

Function HojearTorneos()
//local cArea:=Alias()

dbselectarea('torneos')

LOAD WINDOW ksht AS FrmHT

  CENTER WINDOW FrmHT
  ACTIVATE WINDOW FrmHT
  RELEASE WINDOW
  
//dbselectarea(cArea)

Return Nil

/*
 * Editar torneo
 */

Function EditarTorneo()

Torneos->(dbgoto(FrmHT.brwTorneos.Value))
LOAD WINDOW kset AS FrmET

  FrmET.txtFICHERO.Value:=Torneos->FICHERO
  FrmET.txtTORNEO.Value:=Torneos->TORNEO
  FrmET.fecFeCHA_INI.Value:=Torneos->FECHA_INI
  FrmET.fecFeCHA_FIN.Value:=Torneos->FECHA_FIN
  FrmET.txtLOCALIDAD.Value:=Torneos->LOCALIDAD
  FrmET.txtN_JUGS.Value:=Torneos->N_JUGS
  FrmET.txtN_RONDAS.Value:=Torneos->N_RONDAS
  FrmET.txtN_R_ACTUAL.Value:=Torneos->N_R_ACTUAL
  FrmET.txtPIE_PAG.Value:=Torneos->PIE_PAG
  FrmET.txtPRIM_CONTR.Value:=Torneos->PRIM_CONTR
  FrmET.txtSEGU_CONTR.Value:=Torneos->SEGU_CONTR
  FrmET.txtARBIT_PPAL.Value:=Torneos->ARBIT_PPAL
  FrmET.txtARBIT_AUX.Value:=Torneos->ARBIT_AUX

//  FrmVC.txtNOMBRE.SetFocus

  FrmET.Center
  FrmET.Activate
  RELEASE WINDOW

Return Nil

/*
 * Grabar registro de torneo
 */
Function fOk()

if torneos->(flock())
  REPLACE Torneos->FICHERO WITH FrmET.txtFICHERO.Value
  REPLACE Torneos->TORNEO WITH FrmET.txtTORNEO.Value
  REPLACE Torneos->FECHA_INI WITH FrmET.fecFeCHA_INI.Value
  REPLACE Torneos->FECHA_FIN WITH FrmET.fecFeCHA_FIN.Value
  REPLACE Torneos->LOCALIDAD WITH FrmET.txtLOCALIDAD.Value
  REPLACE Torneos->N_JUGS WITH FrmET.txtN_JUGS.Value
  REPLACE Torneos->N_RONDAS WITH FrmET.txtN_RONDAS.Value
  REPLACE Torneos->N_R_ACTUAL WITH FrmET.txtN_R_ACTUAL.Value
  REPLACE Torneos->PIE_PAG WITH FrmET.txtPIE_PAG.Value
  REPLACE Torneos->PRIM_CONTR WITH FrmET.txtPRIM_CONTR.Value
  REPLACE Torneos->SEGU_CONTR WITH FrmET.txtSEGU_CONTR.Value
  REPLACE Torneos->ARBIT_PPAL WITH FrmET.txtARBIT_PPAL.Value
  REPLACE Torneos->ARBIT_AUX WITH FrmET.txtARBIT_AUX.Value
  torneos->(dbunlock())

else
  MsgInfo('Error al grabar los datos')

endif

FrmET.Release
FrmHT.brwTorneos.Refresh

Return nil


/*
 * Principio del programa
 */

Function Inicializacion()
ksini()

cVar:=descend('a')

dbcloseall()

NoTorneo()
Frm.Title:=APLICACION

//ElegirTorneo()

Return Nil

/*
 */

Function ksini()
  SET CENTURY ON
  SET EPOCH TO 1950
  SET DATE ITAL
  SET DELETED ON
  SET EXCLUSIVE OFF
  SET SOFTSEEK ON
Return nil

/*
 * Fin del programa
 */

Function FinProg()

  dbcloseall()

Return Nil

/*
 * Funcin vaca, para versiones futuras del programa
 */

Function NoHagasNada()

  MsgInfo('Opcin no disponible por el momento')

Return Nil

/*
 */
/*----------------------------------------- Archivos ------------------------------------------------------*/
#include "ksclas.prg"
#include "f_k.prg"
#include "kscfgds.prg"
#include "kscfgs.prg"
#include "kspremios.prg"
#include "kshtml.prg"
#include "kspgn.prg"
#include "kstorneo.prg"
#include "ksinfs.prg"
#include "ksmenus.prg"
#include "ksbasejugs.prg"
#include "ksimpor.prg"
#include "kslists.prg"
