/*
 *  Creacin de las pginas Html del torneo
 */

Function LisHtmPag()
local cFechaw

if !cuadro->(flock())
  MsgInfo('El Cuadro de jugadores est siendo utilizado por otro programa'+CRLF+;
          'No se puede hacer el listado')
  Return nil
endif

//Crear pgina principal
  cFechaw:=if(torneos->fecha_ini<>torneos->fecha_fin,'del '+ ;
            dtoc(torneos->fecha_ini)+' al '+dtoc(torneos->fecha_fin),dtoc(torneos->fecha_ini))
  HtmFich := Html_Ini("\"+CurDir()+"\"+'ks'+lower(torneos->fichero)+".htm",alltrim(torneos->torneo),;
             trim(torneos->localidad)+', '+cFechaw)
  Html_LineText(HtmFich, '<p class="updated">Informe del torneo')
  Html_Line(HtmFich)
  Html_LineText(HtmFich,'<br>')

  Html_Text(HtmFich,'<a href="'+'ks'+lower(torneos->fichero)+'of.htm">Orden de fuerza</a>')
  Html_LineText(HtmFich,'<br>')

  for i:=1 to torneos->n_r_actual

	   Html_LineText(HtmFich,'<a href="'+'ks'+lower(torneos->fichero)+'r'+ ;
               alltrim(str(i))+'.htm">'+'Resultados de la '+;
                alltrim(str(i))+' '+if(i=torneos->n_rondas,'y ltima ','')+'ronda</a>')
	   Html_Text(HtmFich,'<a href="'+'ks'+lower(torneos->fichero)+'c'+ ;
               alltrim(str(i))+'.htm">'+'Clasificacin tras la '+;
                alltrim(str(i))+' '+if(i=torneos->n_rondas,'y ltima ','')+'ronda</a>')
	   Html_LineText(HtmFich,'<br>')

  next

  Html_Line(HtmFich)
  PieHtml(HtmFich)
  Html_End(HtmFich)

  MsgInfo('Pgina principal del torneo creada')

//Crear pgina de orden de fuerza
  LisHtmOF('ks'+lower(torneos->fichero)+'of')

  MsgInfo('Pgina con el orden de fuerza del torneo creada')


//Crear pginas de resultados y clasificacin de cada ronda
  for ii:=1 to torneos->n_rondas

    nRondaw:=ii
    LisHtmPareo(nRondaw,'ks'+lower(torneos->fichero)+'r'+alltrim(str(nRondaw)),.t.)
    LisHtmClas(nRondaw,'ks'+lower(torneos->fichero)+'c'+alltrim(str(nRondaw)))

    //MsgInfo('Pginas de la ronda '+alltrim(str(ii,2))+' creadas')

  next
  MsgInfo('Pginas de cada ronda creadas')

Return Nil

/*
 * Listado Html del Orden de Fuerza
 */

Function LisHtmOF(cFHtm)
local cFechaw

  dbselectarea('cuadro')

  cFechaw:=if(torneos->fecha_ini<>torneos->fecha_fin,'del '+ ;
            dtoc(torneos->fecha_ini)+' al '+dtoc(torneos->fecha_fin),dtoc(torneos->fecha_ini))
  HtmFich := Html_Ini("\"+CurDir()+"\"+cFHtm+".htm",alltrim(torneos->torneo),;
             trim(torneos->localidad)+', '+cFechaw)

  Html_LineText(HtmFich, '<p class="updated">Orden de fuerza')
  Html_Line(HtmFich)

  Html_Text(HtmFich,'<pre>')

  CabeceraOF()

  Html_Line(HtmFich)

  nKLin:=0

  dbeval({|| ProcLinOF()})

  if nKLin%5<>0
    Html_Line(HtmFich)
  endif

  Html_Text(HtmFich,'</pre>')
  
  PieHtml(HtmFich)
  Html_End(HtmFich)

Return Nil

/*
 * Cabecera del orden de fuerza
 */
Function CabeceraOF()
local cLin

  cLin:='   #  Jugador'+space(24)+'Club/Procedencia  Cat/Tt    FIDE     FEDA      Aut'

  Html_LineTextK(HtmFich,cLin)

Return nil

/*
 * Cada lnea del listado del Orden de Fuerza
 */

Function ProcLinOF()
local cLin

  nKLin++
/* modified by erral 27/7/2003 22:55 o2a jarri izena agertzen denean */
  cLin:='('+str(cuadro->num,3)+') '+o2a(cuadro->jug)+' '+cuadro->club+'   '
  cLin+=cuadro->cat+space(10)+tran(cuadro->elofide,"@Z####")+'     '
  cLin+=tran(cuadro->elofeda,"@Z####")+'     '
  cLin+=tran(cuadro->elo,"@####")

  Html_LineTextK(HtmFich,cLin)

  if nKLin%5=0
    Html_Line(HtmFich)
  endif

Return nil

/*
 * Dilogo anterior al listado Html del emparejamiento
 */

Function LisHtmP()
local cFichRda, aRondas[torneos->n_rondas]

aeval(aRondas, {|cValor,nIndice| aRondas[nIndice] := alltrim(str(nIndice)) } )

LOAD WINDOW ksrnw AS FrmElegRda
  CENTER WINDOW FrmElegRda
  ACTIVATE WINDOW FrmElegRda

Return Nil

/*
 * Listado Html del emparejamiento, con o sin resultados
 */

Function LisHtmPareo(nRda,cFHtm,lRdos)
local cFechaw

if !cuadro->(flock())
  MsgInfo('El Cuadro de jugadores est siendo utiliado por otro programa'+CRLF+;
          'No se puede hacer el listado')
  Return nil
endif

nRonda:=nRda-1
ksclas()

  cFichRda="r"+alltrim(str(nRda))+cCodTorneo

  use (cFichRda) alias ronda new

  cFechaw:=if(torneos->fecha_ini<>torneos->fecha_fin,'del '+ ;
            dtoc(torneos->fecha_ini)+' al '+dtoc(torneos->fecha_fin),dtoc(torneos->fecha_ini))
  HtmFich := Html_Ini("\"+CurDir()+"\"+cFHtm+".htm",alltrim(torneos->torneo),;
             trim(torneos->localidad)+', '+cFechaw)

  Html_LineText(HtmFich, '<p class="updated">'+if(lRdos,'Resultados','Emparejamiento')+' de la '+;
                alltrim(str(nRda))+' ronda')

  Html_Line(HtmFich)

  Html_Text(HtmFich,'<pre>Mesa'+space(10)+'Blancas'+space(37)+'Negras'+space(35)+'Rdo')

  Html_Line(HtmFich)

  nKLin:=0
  dbeval({|| ProcLinPareo(lRdos)},{|| ronda->jug_b<>0})

  dbclosearea()

  if nKLin%5<>0
    Html_Line(HtmFich)
  endif

  Html_Text(HtmFich,'</pre>')

  PieHtml(HtmFich)
  Html_End(HtmFich)

  cuadro->(dbunlock())

Return Nil

/*
 * Cada lnea del listado del emparejamiento
 */

Function ProcLinPareo(lRdos)
local cLin:=''

  nKLin++
  cLin+=str(ronda->(recno()),3)+space(5)
  cuadro->(dbgoto(ronda->jug_b))
  /* modified by erral 27/7/2003 22:55 o2a jarri izena agertzen denean */
  cLin+='('+str(cuadro->num,3)+') '+o2a(cuadro->jug)+'('+str(cuadro->ptos,nCifrasNRdas+2,1)+')'

  if ronda->jug_n>0
     cuadro->(dbgoto(ronda->jug_n))
     /* modified by erral 27/7/2003 22:55 o2a jarri izena agertzen denean */
     cLin+=' - '+'('+str(cuadro->num,3)+') '+o2a(cuadro->jug)+'('+str(cuadro->ptos,nCifrasNRdas+2,1)+')'
  else
     cLin+=' - BYE '
  endif

  if lRdos
    cLin+=space(5)+o2a(ronda->rdo)
  endif

  Html_LineTextK(HtmFich,cLin)

  if nKLin%5=0
    Html_Line(HtmFich)
  endif

Return Nil
/*
 * Dilogo anterior al listado Html de la clasificacin
 */

Function LisHtmC()
local cFichRda, aRondas[torneos->n_rondas]

aeval(aRondas, {|cValor,nIndice| aRondas[nIndice] := alltrim(str(nIndice)) } )

LOAD WINDOW ksrncw AS FrmElegRda
  CENTER WINDOW FrmElegRda
  ACTIVATE WINDOW FrmElegRda

Return Nil

/*
 * Listado Html de la clasificacin
 */

Function LisHtmClas(nRda,cFHtm)
Local cFechaw
Private nPtosAnt:=-999

if !cuadro->(flock())
  MsgInfo('El Cuadro de jugadores est siendo utiliado por otro programa'+CRLF+;
          'No se puede hacer el listado')
  Return nil
endif

nRonda:=nRda
ksclas()

//MsgInfo('->'+dw1+'<-')

use cclas new

dbselectarea('cuadro')
ordlistadd('suclas.tmp')
*********
declare nOrd[cuadro->(lastrec())]
nKW:=1
dbeval({|| (nOrd[cuadro->num]:=nKW,nKW++)  })
*********

  cFechaw:=if(torneos->fecha_ini<>torneos->fecha_fin,'del '+ ;
            dtoc(torneos->fecha_ini)+' al '+dtoc(torneos->fecha_fin),dtoc(torneos->fecha_ini))
  HtmFich := Html_Ini("\"+CurDir()+"\"+cFHtm+".htm",alltrim(torneos->torneo),;
             trim(torneos->localidad)+', '+cFechaw)

  Html_LineText(HtmFich, '<p class="updated">Clasificacin '+if(torneos->n_rondas=nRda,'final','tras la '+;
                alltrim(str(nRda))+' ronda'))
  Html_Line(HtmFich)

  Html_Text(HtmFich,'<pre>')

  CabeceraClas()

  Html_Line(HtmFich)

  nKLin:=0

  dbeval({|| ProcLinClas()})      //  ,{|| ronda->jug_b<>0})

  if nKLin%5<>0
    Html_Line(HtmFich)
  endif

  Html_Text(HtmFich,'</pre>')

  PieHtml(HtmFich)
  Html_End(HtmFich)

  cuadro->(dbunlock())
  cuadro->(ordlistclear())

  cclas->(dbclosearea())

Return Nil

/*
 * Cabecera del listado de la clasficacin
 */

Function CabeceraClas()
local cLin:='', nKP:=0

  cLin+=space(5)

  cclas->(dbgotop())

  if cclas->sn
     cLin+='   # '
  endif
  cclas->(dbskip())
  if cclas->sn
     cLin+='Jugador'+space(24)
  endif
  cclas->(dbskip())
  if cclas->sn
     cLin+='Procedencia    '
  endif

  cLin+='Cat '

  cclas->(dbskip())
  if cclas->sn
     cLin+='FIDE '
  endif
  cclas->(dbskip())
  if cclas->sn
     cLin+='Ptos '
  endif
  cclas->(dbskip())

  /* cuadroa lortzekoak */
  for i:=1 to 5
    if cclas->sn
       if i<>2
          nKP:=nKP+1
       else
          nKP:=nKP+3
       endif
    endif
    cclas->(dbskip())
  next
  //cclas->(dbskip(-5))
  /*
  if cclas->sn                 // Si pone el rdo (qu si no?)
  @ PROW(),PCOL()+EDW-1 SAY ""
  endif
  */
  for i:=1 to nRonda

    do case
       case nKP=1
            cLin+=right(str(i,2),1)
       case nKP=2
            cLin+=str(i,2)
       case nKP=3
            cLin+=str(i,2)+''
       case nKP>3
            cLin+=str(i,2)+'R'+if(nKP>4,space(nKP-4),'')
    endcase
  next

  //cclas->(dbskip(5))

  for i:=1 to 5
    if cclas->sn
/*       cTmp:='dw'+str(i,1)
       cLin+=if(upper(&cTmp)='ELO_M',' ','')
       cLin+=&cTmp
*/
       cLin+=if(aDesemps[i]='ELO_M','  ',' ')+aDesemps[i]
    endif
    cclas->(dbskip())
  next

  if cclas->sn
     cLin+='  +ELO'
  endif

  Html_LineTextK(HtmFich,cLin)

Return nil

/*
 * Cada lnea del listado de la clasficacin
 */

Function ProcLinClas()
local cLin:='', nKP:=0

  nKLin++

  cLin+=str(nKLin,3)+'. '

  cclas->(dbgotop())

  if cclas->sn
     cLin+='('+str(cuadro->num,3)+')'
  endif
  cclas->(dbskip())
  if cclas->sn
     cLin+=o2a(cuadro->jug)+' '
  endif
  cclas->(dbskip())
  if cclas->sn
     cLin+=o2a(cuadro->club)+' '
  endif

  cLin+=cuadro->cat+'  '

  cclas->(dbskip())
  if cclas->sn
     cLin+=if(cuadro->elofide>0,str(cuadro->elofide,4),'    ')+' '
  endif
  cclas->(dbskip())
  if cclas->sn
     cLin+=if(cuadro->ptos<>nPtosAnt,str(cuadro->ptos,4,1),+'  " ')+' '
  endif

  nPtosAnt:=cuadro->ptos
  cclas->(dbskip())

  for i:=1 to 5
    if cclas->sn
       if i<>2
          nKP:=nKP+1
       else
          nKP:=nKP+3
       endif
    endif
    cclas->(dbskip())
  next

  cclas->(dbskip(-5))
  if nKP>0
     for i:=1 to nRonda

        for j:=1 to 5
            if cclas->sn
               cCampo:="cuadro->r"+str(i,if(i>9,2,1))+trim(cclas->campo)

               if j=1              && 2
                  cVJ=cCampo       && Luego necesito el contrario
               endif
               do case
                  case j=3    && 1
                  do case
                     case &cCampo="1"
                         cRdo:="+"
                     case &cCampo="0"
                         cRdo:="-"
                     case &cCampo="" .or. &cCampo=""
                         cRdo:="="
                     otherwise
                         cRdo:=" "
                  endcase
                  cLin+=cRdo
                  case j=1     && 2
                       cLin+=if(&cVJ>0,str(&cVJ,3),'   ')
                       //IIF(&VJ>0,IIF(PRW="P",STR(ORD[&VJ],3),STR(&VJ,3)),"   ")
                  otherwise
                       cLin+=lower(&cCampo)
               endcase
            endif
            cclas->(dbskip())
        next
        cclas->(dbskip(-5))
     next
  endif
  cclas->(dbskip(5))

  for i:=1 to 5
    if cclas->sn
/*       cTmp:='dw'+str(i,1)
       cLin+=if(upper(&cTmp)='ELO_M',' ','')
       cLin+=cuadro->&cTmp
*/
       cTmp:='cuadro->'+aDesemps[i]
       //cTmp:=&cTmp
       cLin+=if(aDesemps[i]='ELO_M',' ','')+str(&cTmp,6,1)
    endif
    cclas->(dbskip())
  next

  if cclas->sn
     cLin+=str(cuadro->var_elo,6,1)
  endif

  Html_LineTextK(HtmFich,cLin)

  if nKLin%5=0
    Html_Line(HtmFich)
  endif

Return Nil

/*
 * Pie de pgina de los listados Html
 */
Function PieHtml(HtmFich)

  //Html_Line(HtmFich)
  
  Html_Text(HtmFich,'<table width="100%" border="0" cellspacing="0" cellpadding="0">'+;
            '<tr><td class="pie">'+alltrim(torneos->pie_pag)+;
            '</td><td class="pie"><div align="right">'+;
            alltrim(torneos->arbit_ppal)+'</div></td></tr></table>')

  //Html_Text(HtmFich, APLICACION+' - '+alltrim(torneos->pie_pag))

  //Html_Line(HtmFich)
  Html_Text(HtmFich, '<center>'+APLICACION+' - <a href='+PAGINAWEB+'>'+'AjedrezVasco.com</a></center>')

Return nil
