/*
 *  Creacin del PGN de una ronda del torneo
 */

Function KsCreaPGNRda()
local aRondas[torneos->n_rondas], cFichPGN
/* Es necesario?
if !cuadro->(flock())
  MsgInfo('El Cuadro de jugadores est siendo utilizado por otro programa'+CRLF+;
          'No se puede hacer el listado')
  Return nil
endif
*/
//Elegir ronda
aeval(aRondas, {|cValor,nIndice| aRondas[nIndice] := alltrim(str(nIndice)) } )

LOAD WINDOW ksronda AS FrmElegRda
  CENTER WINDOW FrmElegRda
  ACTIVATE WINDOW FrmElegRda
  
//La ronda elegida est en nRonda y el nombre del fichero en cFich
//MsgInfo(str(nRonda)+CRLF+cFich)
cFichRda='r'+alltrim(str(nRonda))+cCodTorneo
use (cFichRda) alias ronda new

hFichPGN := FCREATE(cFich)

nKLin:=0
dbeval({|| ProcLinRonda()},{|| ronda->jug_b<>0 .and. ronda->jug_n<>0})

FCLOSE(hFichPGN)
MsgInfo('El fichero '+cFich+' ha sido creado')


ronda->(dbclosearea())
//cuadro->(dbunlock())

Return nil
/*
 *  Lnea de Emparejamiento = Partida PGN
 */
Function ProcLinRonda()

nKLin++

/*
[Event "Ajedrez21"]
[Site "www.ajedrez21.com"]
[Date "2003.7.10"]
[Round "3.5"]
[White "vandepeppe"]
[Black "gaztelugatxe"]
[Result "1-0"]
[WhiteElo "2310"]
[BlackElo "2392"]
[TimeControl "2/2"]
*/
FWRITE(hFichPGN,'[Event "'+o2a(trim(torneos->torneo))+'"]'+CRLF)
FWRITE(hFichPGN,'[Site "'+o2a(trim(torneos->localidad))+'"]'+CRLF)
FWRITE(hFichPGN,'[Date "'+str(year(torneos->fecha_ini),4)+'.'+;
                           strzero(month(torneos->fecha_ini),2)+'.'+;
                           strzero(day(torneos->fecha_ini),2)+'"]'+CRLF)
FWRITE(hFichPGN,'[Round "'+alltrim(str(nRonda))+'.'+alltrim(str(nKLin))+'"]'+CRLF)

cuadro->(dbgoto(ronda->jug_b))
FWRITE(hFichPGN,'[White "'+o2a(trim(cuadro->jug))+'"]'+CRLF)
cuadro->(dbgoto(ronda->jug_n))
FWRITE(hFichPGN,'[Black "'+o2a(trim(cuadro->jug))+'"]'+CRLF)

FWRITE(hFichPGN,'[Result "'+if(substr(ronda->rdo,2,3)='-','1/2-1/2',;
                               alltrim(substr(ronda->rdo,2,3)))+'"]'+CRLF)
                               
FWRITE(hFichPGN,'[ECO ""]'+CRLF)

cuadro->(dbgoto(ronda->jug_b))
if cuadro->elofide>0
  FWRITE(hFichPGN,'[WhiteElo "'+str(cuadro->elofide,4)+'"]'+CRLF)
endif
cuadro->(dbgoto(ronda->jug_n))
if cuadro->elofide>0
  FWRITE(hFichPGN,'[BlackElo "'+str(cuadro->elofide,4)+'"]'+CRLF)
endif

FWRITE(hFichPGN,'1.'+CRLF)

Return nil
/*
 *  Creacin del PGN del torneo
 */

Function KsCreaPGN()
local aRondas[torneos->n_rondas], cFichPGN

/*
aeval(aRondas, {|cValor,nIndice| aRondas[nIndice] := alltrim(str(nIndice)) } )

LOAD WINDOW ksronda AS FrmElegRda
  CENTER WINDOW FrmElegRda
  ACTIVATE WINDOW FrmElegRda
*/

cFich:='Ks'+alltrim(torneos->fichero)+'.pgn'
hFichPGN := FCREATE(cFich)

for nRonda:=1 to torneos->n_rondas  
	//La ronda elegida est en nRonda y el nombre del fichero en cFich
	//MsgInfo(str(nRonda)+CRLF+cFich)
	cFichRda='r'+alltrim(str(nRonda))+cCodTorneo
	use (cFichRda) alias ronda new


	nKLin:=0
	dbeval({|| ProcLinRonda()},{|| ronda->jug_b<>0 .and. ronda->jug_n<>0})
	
	ronda->(dbclosearea())

next

FCLOSE(hFichPGN)
MsgInfo('El fichero '+cFich+' ha sido creado')

//cuadro->(dbunlock())

Return nil
/*
 *  Creacin del PGN de un jugador
 */

Function KsCreaPGNJug()
local aJugs:={}, nReg, cRda, cCampo

cuadro->(dbeval({|| aadd(aJugs, cuadro->jug )}))

LOAD WINDOW kselejug AS FrmElegJug
  CENTER WINDOW FrmElegJug
  ACTIVATE WINDOW FrmElegJug

dbselectarea('cuadro')
LOCATE for cuadro->jug=cJug
nReg:=cuadro->(recno())
    
//cFichRda='r'+alltrim(str(nRonda))+cCodTorneo
//use (cFichRda) alias ronda new

hFichPGN := FCREATE(cFich)

nKLin:=0

for i:=1 to torneos->n_r_actual
	
	cRda:=alltrim(str(i))
	// tratar partida

	FWRITE(hFichPGN,'[Event "'+o2a(trim(torneos->torneo))+'"]'+CRLF)
	FWRITE(hFichPGN,'[Site "'+o2a(trim(torneos->localidad))+'"]'+CRLF)
	FWRITE(hFichPGN,'[Date "'+str(year(torneos->fecha_ini),4)+'.'+;
                           strzero(month(torneos->fecha_ini),2)+'.'+;
                           strzero(day(torneos->fecha_ini),2)+'"]'+CRLF)
	FWRITE(hFichPGN,'[Round "'+cRda+'"]'+CRLF)

	cCampo:='cuadro->r'+cRda+'c'
	
	if &cCampo='B'

		//cuadro->(dbgoto(ronda->jug_b))
		FWRITE(hFichPGN,'[White "'+o2a(trim(cuadro->jug))+'"]'+CRLF)
		
		cCampo:='cuadro->r'+cRda+'j'
		cuadro->(dbgoto(&cCampo))
		
		FWRITE(hFichPGN,'[Black "'+o2a(trim(cuadro->jug))+'"]'+CRLF)


		cuadro->(dbgoto(nReg))
		cCampo:='cuadro->r'+cRda+'p'
		FWRITE(hFichPGN,'[Result "'+if(&cCampo$'5','1/2-1/2',;
                  if(&cCampo='1','1-0','0-1'))+'"]'+CRLF)
                               
		FWRITE(hFichPGN,'[ECO "A00"]'+CRLF)

		if cuadro->elofide>0
  			FWRITE(hFichPGN,'[WhiteElo "'+str(cuadro->elofide,4)+'"]'+CRLF)
		endif
		cCampo:='cuadro->r'+cRda+'j'
		cuadro->(dbgoto(&cCampo))
		if cuadro->elofide>0
  			FWRITE(hFichPGN,'[BlackElo "'+str(cuadro->elofide,4)+'"]'+CRLF)
		endif
		cuadro->(dbgoto(nReg))
		
	else

		cCampo:='cuadro->r'+cRda+'j'
		cuadro->(dbgoto(&cCampo))
		FWRITE(hFichPGN,'[White "'+o2a(trim(cuadro->jug))+'"]'+CRLF)
		
		cuadro->(dbgoto(nReg))
		FWRITE(hFichPGN,'[Black "'+o2a(trim(cuadro->jug))+'"]'+CRLF)

		cCampo:='cuadro->r'+cRda+'p'
		FWRITE(hFichPGN,'[Result "'+if(&cCampo$'5','1/2-1/2',;
                               if(&cCampo='0','1-0','0-1'))+'"]'+CRLF)
                               
		FWRITE(hFichPGN,'[ECO "A00"]'+CRLF)

		cCampo:='cuadro->r'+cRda+'j'
		cuadro->(dbgoto(&cCampo))
		if cuadro->elofide>0
  			FWRITE(hFichPGN,'[WhiteElo "'+str(cuadro->elofide,4)+'"]'+CRLF)
		endif
		
		cuadro->(dbgoto(nReg))
		if cuadro->elofide>0
  			FWRITE(hFichPGN,'[BlackElo "'+str(cuadro->elofide,4)+'"]'+CRLF)
		endif
	
	endif

	FWRITE(hFichPGN,'1.'+CRLF)

next

FCLOSE(hFichPGN)
MsgInfo('El fichero '+cFich+' ha sido creado')

//ronda->(dbclosearea())

//dbselectarea()???

Return nil
